stages:
  - deploy

variables:
  # Define your environment-specific variables here
  SSH_PRIVATE_KEY: "$SSH_PRIVATE_KEY"  # Set this as a GitLab secret variable
  SSH_SERVER: "$SERVER_IP"
  SSH_PORT: 22
  SSH_USER: "$SERVER_USERNAME"
  REMOTE_PATH: "/home/gitlab/pdf-manager/backend"
# Define job for deploying the Nuxt.js application
deploy:
    image: python:3.9.18-bullseye
    stage: deploy
    script:
        - apt-get update
        - apt-get install -y openssh-client # Install OpenSSH client
        - mkdir -p ~/.ssh
        - echo "$SSH_PRIVATE_KEY" | tr -d '\r' > ~/.ssh/id_rsa
        - chmod 600 ~/.ssh/id_rsa
        - ssh-keyscan -p $SSH_PORT -H $SSH_SERVER >> ~/.ssh/known_hosts
        - scp -P $SSH_PORT -r ./* $SSH_USER@$SSH_SERVER:$REMOTE_PATH # Upload the Nuxt.js build to the server
        - ssh -p $SSH_PORT $SSH_USER@$SSH_SERVER 'cd /home/gitlab/pdf-manager/backend && docker-compose down'
        - ssh -p $SSH_PORT $SSH_USER@$SSH_SERVER 'cd /home/gitlab/pdf-manager/backend && docker-compose up -d --build'
    only:
        - main # Trigger the deployment only for the none branch (customize as needed)
